var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Fragment as _Fragment, jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useEffect } from 'react';
import BarChart from '../charts/BarChart.js';
import LineChart from '../charts/LineChart.js';
import StackChart from '../charts/StackChart.js';
import PieChart from '../charts/PieChart.js';
import Table from '../charts/Table.js';
import ChartTitle from './ChartTitle.js';
import Filter from './Filter.js';
import { downloadExcel } from './ExcelDownloader.js';
var ChartContainer = function (_a) {
    var _b, _c, _d;
    var setup = _a.setup, index = _a.index, configuration = _a.configuration;
    var _e = React.useState('loading'), status = _e[0], setStatus = _e[1];
    var _f = React.useState([]), chartData = _f[0], setChartData = _f[1];
    var _g = React.useState(null), subChartData = _g[0], setSubChartData = _g[1];
    var _h = React.useState(false), isTableView = _h[0], setIsTableView = _h[1];
    var _j = React.useState(((_b = setup.table) === null || _b === void 0 ? void 0 : _b.page_size) || ((_d = (_c = setup.table) === null || _c === void 0 ? void 0 : _c.page_sizes) === null || _d === void 0 ? void 0 : _d[0]) || 10), pageSize = _j[0], setPageSize = _j[1];
    var _k = React.useState(1), page = _k[0], setPage = _k[1];
    var _l = React.useState(false), isFilterVisible = _l[0], setIsFilterVisible = _l[1];
    var _m = React.useState({}), appliedFilters = _m[0], setAppliedFilters = _m[1];
    var handleToggleViewTable = function (showTable) {
        setIsTableView(showTable);
    };
    var handleDashboardByLink = function (arg) {
        if (configuration.fnHandleDashboardLink) {
            return configuration.fnHandleDashboardLink(arg);
        }
        if (arg.chart_link)
            window.location.href = arg.chart_link;
    };
    var downloadFileExcel = function () {
        var _a, _b, _c;
        if (chartData.length === 0) {
            console.warn('No data to download');
            return;
        }
        var fileName = ((_b = (_a = setup.chart) === null || _a === void 0 ? void 0 : _a.title) === null || _b === void 0 ? void 0 : _b.text) || setup.title || 'chart-data';
        downloadExcel({
            data: chartData,
            setupData: (_c = setup.table) !== null && _c !== void 0 ? _c : undefined,
            fileName: fileName.toLowerCase().replace(/\s+/g, '-'),
        });
    };
    var getChartDataAsync = function (arg) { return __awaiter(void 0, void 0, void 0, function () {
        var result, _a;
        var _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _c.trys.push([0, 2, 3, 4]);
                    setStatus('loading');
                    return [4, configuration.fnGetChartDataAsync(arg)];
                case 1:
                    result = _c.sent();
                    if (!(result === null || result === void 0 ? void 0 : result.data) || result.data.length === 0) {
                        setStatus('empty');
                        setChartData([]);
                        setSubChartData(null);
                    }
                    else {
                        setStatus('loaded');
                        setChartData(result.data.filter(function (item) { return item !== null && item !== undefined; }));
                        setSubChartData(((_b = result.sub) === null || _b === void 0 ? void 0 : _b.filter(function (item) { return item !== undefined; })) || null);
                    }
                    return [3, 4];
                case 2:
                    _a = _c.sent();
                    setStatus('error');
                    setChartData([]);
                    setSubChartData(null);
                    return [3, 4];
                case 3:
                    setIsFilterVisible(false);
                    return [7];
                case 4: return [2];
            }
        });
    }); };
    var onPageChange = function (page) {
        setPage(page);
    };
    var onPageSizeChange = function (pageSize) {
        setPageSize(pageSize);
    };
    var handleShowFilter = function () { return setIsFilterVisible(true); };
    var handleFilterClose = function () { return setIsFilterVisible(false); };
    var handleFilterApply = function (filters) {
        setAppliedFilters(filters);
    };
    useEffect(function () {
        var _a;
        if ((_a = setup.parameters) === null || _a === void 0 ? void 0 : _a.some(function (item) { var _a; return ((_a = item === null || item === void 0 ? void 0 : item.validation) === null || _a === void 0 ? void 0 : _a.required) && !item.default && Object.keys(appliedFilters).length === 0; })) {
            setIsFilterVisible(true);
            return;
        }
        getChartDataAsync({
            id: setup.id,
            limit: pageSize,
            offset: (page - 1) * pageSize,
            filter: __assign({}, appliedFilters),
        });
    }, [setup.id, configuration.fnGetChartDataAsync, page, pageSize, appliedFilters]);
    var renderChartComponent = function () {
        if (status !== 'loaded') {
            return _jsx(_Fragment, {});
        }
        if (isTableView) {
            return (_jsx(Table, { setup: setup, chartData: chartData, onPageChange: onPageChange, onPageSizeChange: onPageSizeChange }, index));
        }
        switch (setup.type) {
            case 'vertical-bar-chart':
            case 'horizontal-bar-chart':
                return _jsx(BarChart, { setup: setup, chartData: chartData }, index);
            case 'line-chart':
            case 'step-line-chart':
                return _jsx(LineChart, { setup: setup, chartData: chartData }, index);
            case 'pie-chart':
                return _jsx(PieChart, { setup: setup, chartData: chartData }, index);
            case 'stack-area-chart':
            case 'stack-bar-chart':
                return _jsx(StackChart, { setup: setup, chartData: chartData }, index);
            case 'table':
                return (_jsx(Table, { setup: setup, chartData: chartData, onPageChange: onPageChange, onPageSizeChange: onPageSizeChange }, index));
            default:
                return _jsxs("div", { children: ["Unknown chart type: ", JSON.stringify(setup)] }, index);
        }
    };
    var renderSubChartComponent = function () {
        if (status !== 'loaded' || !configuration.fnGetSubComponentChartItem || !subChartData) {
            return _jsx(_Fragment, {});
        }
        return configuration.fnGetSubComponentChartItem({ subData: subChartData, setup: setup });
    };
    var renderNoData = function () {
        if (status === 'loading') {
            if (configuration.loadingComponentChartItem)
                return configuration.loadingComponentChartItem;
            return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-loading", children: _jsx("h1", { children: "Loading chart item..." }) }));
        }
        if (status === 'empty') {
            if (configuration.emptyComponentChartItem)
                return configuration.emptyComponentChartItem;
            return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-empty", children: _jsx("h1", { children: "No data for chart item" }) }));
        }
        if (status === 'error') {
            if (configuration.errorComponentChartItem)
                return configuration.errorComponentChartItem;
            return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-error", children: _jsx("h1", { children: "Error chart item" }) }));
        }
    };
    return (_jsxs("div", { className: "s-dasboard__item", style: {
            gridColumn: "".concat(Number(setup.x) + 1, " / span ").concat(setup.width),
            gridRow: "".concat(Number(setup.y) + 1, " / span ").concat(setup.height),
        }, children: [_jsx(ChartTitle, { setup: setup, onToggleView: handleToggleViewTable, handleLinkChart: handleDashboardByLink, handleDownloadExcel: downloadFileExcel, onShowFilter: handleShowFilter }), renderNoData(), renderChartComponent(), renderSubChartComponent(), isFilterVisible && setup.parameters && setup.parameters.length > 0 && (_jsx(Filter, { parameters: setup.parameters, onApply: handleFilterApply, onClose: handleFilterClose, initialFilters: appliedFilters }))] }, index));
};
export default ChartContainer;
